PROGRAM MAIN
VAR CONSTANT
    strDollar                       : STRING :='$$';
    strApostroph                    : STRING :='$'';
    strLF                           : STRING :='$L';
    strCR                           : STRING :='$R';
    strNL                           : STRING :='$N';
    strFF                           : STRING :='$P';
    strTab                          : STRING :='$T';
    
    SIO_INIT_PARITY_NO              : USINT  := 0;
    SIO_INIT_PARITY_ODD             : USINT  := 1;
    SIO_INIT_PARITY_EVEN            : USINT  := 2;
    
    SIO_INIT_PROTOCOL_NO            : USINT  := 0;
    SIO_INIT_PROTOCOL_XON_XOFF      : USINT  := 1;
    SIO_INIT_PROTOCOL_RTS_CTS       : USINT  := 2;
    
    SIO_INIT_ERR_SUCCESS            : USINT  := 0;
    SIO_INIT_ERR_HW_ERROR           : USINT  := 1;
    SIO_INIT_ERR_INVALID_PORT       : USINT  := 2;
    SIO_INIT_ERR_INVALID_BAUD       : USINT  := 8;
    SIO_INIT_ERR_INVALID_DATABITS   : USINT  := 16;
    SIO_INIT_ERR_INVALID_PARITY     : USINT  := 32;
    SIO_INIT_ERR_INVALID_STOPBITS   : USINT  := 64;
    SIO_INIT_ERR_INVALID_PROTOCOL   : USINT  := 128;
    
    SIO_RSTR_ERR_SUCCESS            : USINT  := 0;
    SIO_RSTR_ERR_HW_ERROR           : USINT  := 1;
    SIO_RSTR_ERR_INVALID_PORT       : USINT  := 2;
    SIO_RSTR_ERR_NO_EOT_CHAR        : USINT  := 8;
    SIO_RSTR_ERR_ECHO_NOT_SUPPORTED : USINT  := 16;
    SIO_RSTR_ERR_EDIT_NOT_SUPPORTED : USINT  := 32;
    SIO_RSTR_ERR_NOT_INITIALIZED    : USINT  := 255;
        
    PORTNUM                         : USINT  := 2;
END_VAR

VAR
    astrDisplayText_20x4        : ARRAY [1..4] OF STRING(20) := [   (* |--------------------| *)
                                                                       'Encoded ID number:'  ,
                                                                       '',
                                                                       'Real ID number:' ,
                                                                       ''
                                                                ];
    FB_Lcd_Initialize           : Lcd_Initialize;
    FB_Lcd_ClearScreen          : Lcd_ClearScreen;
    FB_Lcd_WriteString          : Lcd_WriteString;
        
    FB_MqttGetCapabilities      : MQTT_GET_CAPABILITIES;
    FB_MqttConnect              : MQTT_CONNECT;
    FB_MqttPublish              : MQTT_PUBLISH;
    FB_MqttDisconnect           : MQTT_DISCONNECT;
    I2cHandle                   : HI2C;
    usiDisplayLineIdx           : USINT;

    xConfirm                    : BOOL;
    usiError                    : USINT;

    iProcState                  : INT               := 0;

    RFIDdata                    : STRING            := '';
    Dec_data                    : STRING            := '';
    
    iIntVar                     : UDINT;
    pVar                        : POINTER;
    usiRes                      : USINT;
    strResult                   : STRING;

    FB_SioInit                  : SIO_INIT;
    xInitOk                     : BOOL              :=  False;
    
    strRxText                   : STRING(32);
    usiEotChr                   : USINT             := 16#0D;
    xEcho                       : BOOL              := TRUE;
    xEdit                       : BOOL              := TRUE;
    FB_SioReadStr               : SIO_READ_STR;
    iRxDataSize                 : INT;
    iRxStrConfirm               : BOOL              := FALSE;
    xWaitForReceipt             : BOOL              := FALSE;
    
    usiMaxConnections           : USINT             := 0;
    mqttMaxTlsLevel             : MQTT_TLS_LEVEL    := TLS_NOT_USED;
    xSysAutoKeepAlive           : BOOL              := FALSE;
    mqttMaxSubQoS               : MQTT_QOS_LEVEL    := QOS_0;
    mqttMaxPubQoS               : MQTT_QOS_LEVEL    := QOS_0;
    
    strHostUrl                  : STRING            := '192.168.10.155';    
    uiPortNum                   : UINT              := 1883;
    strClientName               : STRING            := 'TestClien';
    strUserName                 : STRING            := 'TestUser';
    strPassword                 : STRING            := 'TestPassword';
    mqttRequTlsLevel            : MQTT_TLS_LEVEL    := TLS_NOT_USED;
    tmAckTimeout                : TIME              := t#3s;
    tmKeepAliveInterval         : TIME              := t#0s;        
    xAutoKeepAlive              : BOOL              := FALSE;
    xCleanSession               : BOOL              := TRUE;
    strLwtTopic                 : STRING            := 'Will';
    pLwtPayload                 : POINTER;
    mqttLwtPubQoS               : MQTT_QOS_LEVEL    := QOS_0;
    xLwtRetained                : BOOL              := FALSE;
    xTlsMode                    : BOOL              := FALSE;
    
    strPubTopic                 : STRING            := 'Topic/Publish';
    strPubPayload               : STRING            := 'Default';
    pPubPayload                 : POINTER;
    mqttPubQoS                  : MQTT_QOS_LEVEL    := QOS_0;
    xPubRetained                : BOOL              := FALSE;
    
    mqttHandle                  : HMQTT             := 0;
    xEnable                     : BOOL              := TRUE;
    iLastErrState               : INT               := -1;
    usiLastError                : USINT             := 0;

END_VAR


    CASE iProcState OF
    (* ------------------------------------------------------------------------------------ *)
    (*  Initialize LCD Driver                                                               *)
    (* ------------------------------------------------------------------------------------ *)

    0:  
        FB_Lcd_Initialize (xEnable_i := FALSE);    
        iProcState := iProcState + 1;

    1:
        FB_Lcd_Initialize (
            xEnable_i := TRUE
            |
            I2cHandle := I2cHandle_o,
            xConfirm  := xConfirm_o,
            usiError  := usiError_o);

        IF (xConfirm = TRUE) THEN
            iProcState := iProcState + 1;
            RETURN;
        END_IF;
        
        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;

    2:  
        FB_SioInit (
            BAUD        := 9600,
            DATABITS    := 8,
            PARITY      := SIO_INIT_PARITY_NO,
            STOPBITS    := 1,
            PROTOCOL    := SIO_INIT_PROTOCOL_NO,
            ENABLE      := TRUE,
            PORT        := PORTNUM
            |
            usiError    := ERROR);

        IF (usiError = SIO_INIT_ERR_SUCCESS) THEN
            xInitOk := TRUE;
            iProcState := iProcState + 1;
            RETURN;
        END_IF;

        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;
    3:
        xEnable := FALSE;
        iProcState := iProcState + 1;
        RETURN;
    
    
    4:  
        FB_MqttGetCapabilities(
            ENABLE              := TRUE
            |
            usiMaxConnections   := MAX_CONNECTIONS,
            mqttMaxTlsLevel     := MAX_TLS_LEVEL,
            xSysAutoKeepAlive   := AUTO_KEEP_ALIVE,
            mqttMaxSubQoS       := MAX_SUB_QOS,
            mqttMaxPubQoS       := MAX_PUB_QOS,
            xConfirm            := CONFIRM,
            usiError            := ERROR);
    
        IF (usiError <> 0) THEN
            usiLastError  := usiError;
            iLastErrState := iProcState;
            iProcState    := -1;
            RETURN;
        END_IF;

        IF (xConfirm = TRUE) THEN
            iProcState := iProcState + 1;
            RETURN;
        END_IF;

        IF (xEnable = FALSE) THEN
            xEnable := TRUE;
            RETURN;
        END_IF;
    
    5:
        xEnable := FALSE;
        iProcState := iProcState + 1;
        RETURN;

    6:   
        pLwtPayload := null;
        FB_MqttConnect (
            HOST_URL            := strHostUrl,
            PORT_NUM            := uiPortNum,
            CLIENT_NAME         := strClientName,
            USER_NAME           := strUserName,
            PASSWORD            := strPassword,
            REQ_TLS_LEVEL       := mqttRequTlsLevel,
            ACK_TIMEOUT         := tmAckTimeout,
            KEEP_ALIVE_INTV     := tmKeepAliveInterval,
            AUTO_KEEP_ALIVE     := xAutoKeepAlive,
            CLEAN_SESSION       := xCleanSession,
            LWT_TOPIC           := strLwtTopic,
            LWT_PAYLOAD         := pLwtPayload,
            LWT_PUB_QOS         := mqttLwtPubQoS,
            LWT_RETAINED        := xLwtRetained,
            ENABLE              := xEnable
            |
            mqttHandle          := MQTT_HANDLE,
            xTlsMode            := TLS_MODE,
            xConfirm            := CONFIRM,
            usiError            := ERROR);
        
        IF (usiError <> 0) THEN
            usiLastError  := usiError;
            iLastErrState := iProcState;
            iProcState    := -1;
            RETURN;
        END_IF;

        IF (xEnable = FALSE) THEN
            xEnable := TRUE;
            RETURN;
        END_IF;

        IF (xConfirm = TRUE) THEN
            iProcState := iProcState + 1;
            RETURN;
        END_IF;
    

    7:  
        FB_SioReadStr (
            ENABLE := FALSE,
            RXDATA := strRxText,
            PORT := PORTNUM
            |
            usiError := ERROR);

        IF (usiError = SIO_RSTR_ERR_SUCCESS) THEN
            xWaitForReceipt := TRUE;
            iProcState := iProcState + 1;
            RETURN;
        END_IF;     

    8:  
        FB_SioReadStr (
            ENABLE := TRUE,
            RXDATA := strRxText,
            MAXLENGTH := 0,
            EOTCHR := usiEotChr,
            ECHO := xEcho,
            Edit := xEdit,
            PORT := PORTNUM
            |
            iRxStrConfirm := CONFIRM,
            usiError := ERROR,
            iRxDataSize := RXLENGTH);

        IF (iRxDataSize = 14) THEN
            RFIDdata := MID(strRxText, 12, 2);
            astrDisplayText_20x4[2] := RFIDdata;
            iProcState := iProcState + 1;
            RETURN;
        END_IF;
        
        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;
        
    9:  
        Dec_data:= MID(RFIDdata, 8, 3);
        pVar := &iIntVar;
        usiRes:= STR_TO_BIN(Dec_data, pVar, 'X');
        strResult := BIN_TO_STR(pVar,'d');
        astrDisplayText_20x4[4] := strResult;
        strPubPayload := strResult;
        iProcState := iProcState + 1;



    (* ------------------------------------------------------------------------------------ *)
    (*  Clear Screen                                                                        *)
    (* ------------------------------------------------------------------------------------ *)
  
    10: 
        FB_Lcd_ClearScreen (xEnable_i := FALSE);    
        iProcState := iProcState + 1;

    11:
        FB_Lcd_ClearScreen (
            xEnable_i   := TRUE,
            I2cHandle_i := I2cHandle
            |
            xConfirm    := xConfirm_o,
            usiError    := usiError_o);

        IF (xConfirm = TRUE) THEN
            usiDisplayLineIdx := 1;
            iProcState := iProcState + 1;
            RETURN;
        END_IF;
        
        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;



    (* ------------------------------------------------------------------------------------ *)
    (*  Print RFID Tag on LCD                                                               *)
    (* ------------------------------------------------------------------------------------ *)

    12: 
        FB_Lcd_WriteString (xEnable_i := FALSE);    
        iProcState := iProcState + 1;

    13:
        FB_Lcd_WriteString (
            xEnable_i   := TRUE,
            I2cHandle_i := I2cHandle,
            usiLine_i   := usiDisplayLineIdx,
            strText_i   := astrDisplayText_20x4[usiDisplayLineIdx]
            |
            xConfirm    := xConfirm_o,
            usiError    := usiError_o);

        IF (xConfirm = TRUE) THEN
            IF (usiDisplayLineIdx < 4) THEN
                usiDisplayLineIdx := usiDisplayLineIdx + 1;
                iProcState := iProcState - 1;
            ELSE
                iProcState := iProcState + 1;
            END_IF;
            RETURN;
        END_IF;
        
        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;



    (* ------------------------------------------------------------------------------------ *)
    (*  Publish RFID Tag via MQTT                                                           *)
    (* ------------------------------------------------------------------------------------ *)

    14:
        xEnable := FALSE;
        iProcState := iProcState + 1;
        RETURN; 

    15:
        pPubPayload := &strPubPayload;
        FB_MqttPublish(
            MQTT_HANDLE         := mqttHandle,
            TOPIC               := strPubTopic,
            PAYLOAD             := pPubPayload,
            PUB_QOS             := mqttPubQoS,
            RETAINED            := xPubRetained,
            ENABLE              := xEnable
            |
            xConfirm            := CONFIRM,
            usiError            := ERROR);
        
        
        IF (usiError <> 0) THEN
            usiLastError  := usiError;
            iLastErrState := iProcState;
            iProcState    := 17;
            RETURN;
        END_IF;

        IF (xConfirm = TRUE) THEN
            pPubPayload:= null;
            iProcState := iProcState + 1;
            RETURN;
        END_IF;

        IF (xEnable = FALSE) THEN
            xEnable := TRUE;
            RETURN;
        END_IF;



    (* ------------------------------------------------------------------------------------ *)
    (*  Finish                                                                              *)
    (* ------------------------------------------------------------------------------------ *)

    16:  (* ---- Finish ---- *)
        iProcState := 7;
        RETURN;


    17:
        FB_MqttDisconnect (
        MQTT_HANDLE         := mqttHandle,
        ENABLE              := xEnable
        |
        xConfirm            := CONFIRM,
        usiError            := ERROR);
        
        IF (usiError <> 0) THEN
            usiLastError  := usiError;
            iLastErrState := iProcState;
            iProcState    := -1;
            RETURN;
        END_IF;

        IF (xConfirm = TRUE) THEN
            pPubPayload:= null;
            iProcState := 4;
            RETURN;
        END_IF;

        IF (xEnable = FALSE) THEN
            xEnable := TRUE;
            RETURN;
        END_IF;


        
    (* ------------------------------------------------------------------------------------ *)
    (*  Error                                                                               *)
    (* ------------------------------------------------------------------------------------ *)

    -1:  (* ---- Error ---- *)
        RETURN;

    ELSE
        RETURN;

    END_CASE;

    RETURN;



END_PROGRAM